<?php

include '../../core.php';

checkAuth("pkiOper");

cabecera (5);

$command = $_POST['request_command'];

switch ($command) {

   default:

      echo "<h1 class='title'>Selecci&oacute;n del fichero de inportaci&oacute;n de certificados</h1>\n";

      echo "<form method='post' action='data_import.php' enctype='multipart/form-data' name='request_import_selfile'>
      <table>
         <tr><td> Fichero XML: </td>
             <td><input type='file' name=ca2raFile size=35></td><td><font size='1'></td></tr>
         <tr><td><input type='submit' value='Importar' /></td></tr>
      </table>
      <input type='hidden' name='request_command' value='request_import' />
      </form>";
      break;

   case "request_import":

      $errorCounter = 0;
      $csrFileName = $_FILES['ca2raFile']['name'];

      echo "<h1 class='title'>Importaci&oacute;n de Certificados</h1>\n";

      // Pasamos el archivo XML a una matriz
      $ca2raArray = parseXML($ca2raFile);
      // Obtenemos el tipo de XML para comprobar si es valido
      $xmlType = $ca2raArray[0]['xmlType'];      
      
      if ( $ca2raArray != false && $xmlType == '"crt"' ) {	      
         // Vemos cuantos certificados hay en el fichero
         $requestsNum = count($ca2raArray);
         // Para cada certificado tendremos que generar un array y volcarlo al 
	 // ldap. Empieza desde la posicion 1 de la matriz porque en la 0 
	 // contiene informacion del fichero en lugar de una solicitud
         for($i=1; $i < $requestsNum; $i++) {
            $errorNumber = 0;
	    
            // Valores comunes 
            $copaId = $ca2raArray[$i]['copa_id'];
            $dn = $ldapVar{rdnAttr} . "=$copaId,$base";
            $id = $ca2raArray[$i]['id'];
	    $status = $ca2raArray[$i]['status'];
            $date = $ca2raArray[$i]['date'];

            // Creamos un array con la informacion a anyadir al ldap	    
            $info['pkirisStatus'] = $status;
            $info['pkirisDate'] = $date;
	    
	    // Tenemos que ver si se trata de un certificado emitido,
            // revocado o una solicitud rechazada por la CA
            $request_type = $ca2raArray[$i]['requesttype'];
					  	    
            if ($request_type == "crt") {
               // Para poder insertar el certificado en el ldap, tenemos que 
	       // asegurarnos de que existe una solicitud con ese numero copa
	       // y con estado "ra2ca"
   	       $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copaId)(pkirisStatus=ra2ca))";
               $justthese = array ("count", "pkiriscerttype");
               $result = ldap_get_info($base, $filter, $justthese);

               if ($result["count"] == 0) {
                  $errorDescription = "\n<p>No existe ninguna CSR pendiente de ser firmada con n&uacute;mero copa $copaId.</p>\n";
                  $errorNumber = 69; 
                  $errorCounter++;
               }
               // En este caso, preparamos los datos a importar al ldap
               else {
		  // Obtenemos el certificado del XML en formato '.pem'. 
		  // Primero tenemos que pasarlo a un fichero 
		  $txtFile = $crtData . $copaId.".txt";
                  // Verificamos si existe el fichero y si no lo creamos y
                  // volcamos la info del certificado en el
                  if (!file_exists($txtFile)) {
                     $txt = fopen($txtFile, "w");
		     fputs($txt, $ca2raArray[$i]['data']);
		     fclose($txt);
		  }

                  // Ahora ya lo podemos pasar de 'txt' a 'pem'		  
		  $pemFile = $crtData . $copaId.".pem";
		  $opensslCommand = $binOpenssl . " x509 < $txtFile  > $pemFile";
		  
		  $execReturn = system($opensslCommand, $retVal);

		  // Pasamos de formato '.pem' a '.der' para poder insertarlo
		  // en el ldap. El fichero tendra una extension u otra 
		  // dependiendo del tipo de certificado (usuario o servidor)
		  $crtType = $result[0]["pkiriscerttype"][0];

		  if ( $crtType == "usr" )
 		     $derFile = $crtData . $copaId .".cer"; 
		  else
		     $derFile = $crtData . $copaId .".x509sv";
		     
                  $opensslCommand2 = $binOpenssl . " x509 -in $pemFile -inform PEM -out $derFile -outform DER";

		  $execReturn2 = system($opensslCommand2, $retVal2);
		  
		  $derFd = fopen ($derFile, "r");
		  if ($derFd == false) {
		     $errorDescription = "\n<p>No se ha podido abrir el fichero .der con el certificado cuyo c&oacute;digo copa es $copaId.</p>\n";
                     $errorNumber = 69;
                     $errorCounter++;
		  }
		  
		  else {
		     // Pasamos el certificado a una cadena
	             $ldapCertString = "";
		     while (!feof($derFd)) {
		        $buf = fgets($derFd, 4096);
		        $ldapCertString = $ldapCertString . $buf;
		     }	
		 
                     $info['userCertificate;binary'] = $ldapCertString;	       
                     $info['pkirisCertificateExpirationDate'] = $ca2raArray[$i]['expiration_date'];

		     list($raCopa, $k) = split("b", $copaId);
		     $filter2 = "(&(objectClass=pkirisAuthority)(pkirisCopaID=$raCopa))";
		     $justthese2 = array("pkirisRaUrl");
		     $result2 = ldap_get_info($base, $filter2, $justthese2);
 
       		     if (!$result2) {
                        $error = 69;
	                echo "<h2>No se ha encontrado ninguna Autoridad de Registro en el sistema con ese c&oacute;digo copa.</h2>";
	             }
                     else {			 
		        $crtRaUrl = $result2 [0]["pkirisraurl"][0];
		        $downloadLink = $pkiUrl . $crtRaUrl . "/crt_get.php";
	    	        $mailSubject = "Certificado Emitido";
		        $mailBody = "El certificado cuyo identificador es $id y n&uacute;mero copa $copaId ha sido emitido. Puede descargarlo de: $downloadLink .";
		     }
	          }
               }
            }
            else if ( $request_type == "rvk" ) { 
       	       // Si no hay ningun certificado firmado con ese numero copa no 
	       // podremos llevar a cabo la revocacion
               $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copaId)(pkirisStatus=ra2ca))";
               $justthese = array ("count");
               $result = ldap_get_info($base, $filter, $justthese);
	    
               if ($result["count"] == 0){
                  $errorDescription = "\n<p>No existe ning&uacute;n certificado pendiente de ser revocado con c&oacute;digo copa $copaId.</p>";
                  $errorNumber = 69;
                  $errorCounter++;
               }
               // El caso de que si exista el certificado, guardamos el motivo
               // de revocacion en la misma entrada
               else {
               
                  $lastStatus = getStatus($copaId);
              
                  // Nos aseguramos de que no se haya tratado la CRR anteriormente 
                  if ($lastStatus == $status) {
                     echo "\n<p>La solicitud de revocaci&oacute;n con n&uacute;mero copa $copaId ya se ha importado anteriormente y a&uacute;n no ha sido tratada.</p>\n";
                     $errorNumber = 69;
                     $errorCounter++;
                  }
		  else {
		      $mailSubject = "Certificado Revocado";
                      $mailBody = "El certificado cuyo identificador es $id ha sido revocado.";
                  }		  
               }
            }
	    
	    if ( $request_type == "rfd" ) {
  	       // Si no hay ninguna solicitud de certificado o revocacion 
	       // pendiente con ese numero copa no podremos rechazarla
               $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copaId)(pkirisStatus=ra2ca))";
               $justthese = array ("count");
               $result = ldap_get_info($base, $filter, $justthese);

               if ($result["count"] == 0) {
                  $errorDescription = "\n<p>No existe ninguna solicitud pendiente de ser procesada con c&oacute;digo copa $copaId.</p>\n";
	          $errorNumber = 69;
	          $errorCounter++;
	       }
	
               else {
                  $lastStatus = getStatus($copaId);
                  // Nos aseguramos de que no se haya tratado la CRR anteriormente
                  if ($lastStatus == $status) {
                     $errorDescription = "\n<p>La solicitud de revocaci&oacute;n con n&uacute;mero copa $copaId ya se ha importado anteriormente y a&uacute;n no ha sido tratada.</p>\n";
	             $errorNumber = 69;
	             $errorCounter++;
	          }
	          else {
	             $mailSubject = "Solicitud Rechazada";
		     $mailBody = "La solicitud cuyo identificador es $id ha sido rechazada.";
                  }
	       }
	    }
				    
            // Si no ha habido ningun error, escribimos los datos en el ldap
	    if ($errorCounter == 0) {
     		    
  	       // Escribimos los datos en el ldap
               $r = ldap_mod_info($dn,$info);
	       if (!$r) {
                  $errorNumber = 69;
                  $errorCounter++;
		  $errorDescription = "\n<p>No se ha podido modificar la informaci&oacute;n del ldap.</p>\n";
               }
	    
	       else {
		  // Escribimos las trazas
		  $urn['pkirisTrace'] = $ca2raArray[$i]['traces'];
		  $r = ldap_mod_add_info($dn,$urn);
	    
                  if (!$r) {
    	             $errorNumber = 69;
                     $errorCounter++;
		     $errorDescription = "\n<p>No se ha podido modificar la informaci&oacute;n del ldap.</p>\n";
                  }
		  
		  // Si todo va bien, le enviamos un correo al responsable del 
		  // certificado para informarle de la firma o revocacion del
		  // mismo
		  $mail = getMail($copaId);
		  $envioMail = mail($mail, $mailSubject, $mailBody);
	       }
	    }
         }
      }
      else {
	 $error = 69;    	 
         $errorCounter ++;
	 $errorDescription = "\n<p>No se ha podido procesar el fichero de importaci&oacute;n $csrFileName.</p>\n";
      }
      
      if ($errorCounter == 0)
         echo "<h2>La importaci&oacute;n se ha realizado con &eacute;xito.</h2>";
      else
         echo "<h2>Error Importando las Solicitudes</h2> " . $errorDescription;
		     
   break; 
}

pie ();

?>
